unit DesktopIntegrate;

interface

uses registry, windows, autoinst, forms;

procedure Integrate;
procedure Disintegrate;

implementation

procedure Integrate;
var
    Registry: TRegistry;
const
    //This could probably be anything...
    DOC_CREATOR_ID = 1380270436;
begin
    Registry := TRegistry.Create;
    Registry.RootKey := HKEY_CURRENT_USER;

 	  //Make sure the desktop is there and find out where it is
    if not Registry.OpenKey('Software\U.S. Robotics', False) then
        if not Registry.OpenKey('Software\Palm Computing', False) then
            raise EPalmDesktopError.Create('The PalmPilot Desktop software is not correctly installed.');

    //The Registry object is now pointing to the correct location
    try
        Registry.OpenKey('Pilot Desktop', False);
        Registry.OpenKey('ApplicationDocReader', True);

        Registry.WriteString('Arguments', '-Desktop');
        Registry.WriteInteger('Creator', DOC_CREATOR_ID);
        Registry.WriteInteger('Integrate', 1);
        Registry.WriteString('Name', 'Reader');
        Registry.WriteString('Module', Application.ExeName);
    finally
        Registry.Free;
    end;
end;


procedure Disintegrate;
var
    Registry: TRegistry;
begin
    Registry := TRegistry.Create;
    Registry.RootKey := HKEY_CURRENT_USER;

 	  //Make sure the desktop is there and find out where it is
    if not Registry.OpenKey('Software\U.S. Robotics', False) then
        if not Registry.OpenKey('Software\Palm Computing', False) then
            raise EPalmDesktopError.Create('The PalmPilot Desktop software is not correctly installed.');

    //The Registry object is now pointing to the correct location
    try
        Registry.OpenKey('Pilot Desktop', False);
        Registry.DeleteKey('ApplicationDocReader');
    finally
        Registry.Free;
    end;
end;


end.
 