unit frmUserUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, autoinst;

type
  TfrmUser = class(TForm)
    cbUsers: TComboBox;
    pbOK: TButton;
    pbCancel: TButton;
    Label1: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure pbOKClick(Sender: TObject);
  private
    UserData: TUserData;
  public
    FileName: String;
  end;

var
  frmUser: TfrmUser;

implementation

{$R *.DFM}


procedure TfrmUser.FormCreate(Sender: TObject);
begin
    try
      UserData := TUserData.Create;
    except
      on EPalmDesktopError do
    end;
end;


procedure TfrmUser.FormShow(Sender: TObject);
var
    I: Integer;
begin
    //Fill the User combo box
    if UserData.GetNumUsers <> 0 then
    begin
      cbUsers.Enabled := True;
      cbUsers.Clear;
      for I := 0 to UserData.GetNumUsers-1 do
        cbUsers.Items.Add(UserData.GetUserName(I));
      cbUsers.ItemIndex := UserData.GetLastUserNumber;
    end
    else
      cbUsers.Enabled := False;
end;


procedure TfrmUser.FormDestroy(Sender: TObject);
begin
    UserData.Free;
end;


procedure TfrmUser.pbOKClick(Sender: TObject);
begin
    UserData.InstallUser(cbUsers.ItemIndex, FileName);
end;

end.
