/*********************************************************************
 * Filename:      common.h
 * Description:   Common things to both PalmPilot and Un*x components
 * Author:        Per Harald Myrvang <perm@stud.cs.uit.no>
 * 	
 * 	Copyright University of Troms (Norway)
 * 	See the file COPYING for details
 ********************************************************************/

#ifndef COMMON_H
#define COMMON_H


/* 1998-01-24T01.23.34.000+0100 */
/* 0000000001111111111222222222 */
/* 1234567890123456789012345678 */
#define SDSI_DATE_LEN		28

#define SECRET_MAXLEN	16		/* 128 bits. */
#define USERNAME_MAXLEN	10

#define REQUEST_OPEN	"REQUEST OPEN"
#define REQUEST_LOCK	"REQUEST LOCK"

#define ACK_OK		"OK\n"		/* OK, i.e. authenticated */
#define ACK_NOEFFECT	"NF\n"		/* The door is already locked/opened */
#define ACK_FAILED	"FA\n"		/* Failure, i.e. not authenticated */
#define ACK_LEN		3		/* All acks are 3 bytes long */

enum ack_n { ack_OK, ack_NOEFFECT, ack_FAILED };

#define DEBUG_SECRET	"secret"	/* O'boy, the top-sekrit debug-secret */

#define DOOR_STATE_OPEN 0
#define DOOR_STATE_LOCK 1


#endif /* COMMON_H */
