/*
 * palm-db-tools: Field definitions for flat-file database objects.
 * Copyright (C) 2000 by Tom Dyas (tdyas@users.sourceforge.net)
 */

#ifndef __PALMLIB_FLATFILE_FIELD_H__
#define __PALMLIB_FLATFILE_FIELD_H__

#include <string>

#include "libpalm/palmtypes.h"

namespace PalmLib {
    namespace FlatFile {

	class Field {
	public:
	    Field() { }
	    ~Field() { }

	    enum FieldType {
		STRING,
		BOOLEAN,
		INTEGER,
		FLOAT,
		DATE,
		TIME,
		DATETIME
	    };

	    enum FieldType type;

	    std::string v_string;
	    bool v_boolean;
	    pi_int32_t v_integer;
	    double v_float;
	    pi_uint32_t v_date;
	    pi_uint32_t v_time;
	    pi_uint32_t v_datetime;
	};

    }
}

#endif
