// PDB.h : include file for PDB reading utilities
//

#if !defined(AFX_PDB_H__13A883DA_766F_11D3_B790_00508B0ACA0E__INCLUDED_)
#define AFX_PDB_H__13A883DA_766F_11D3_B790_00508B0ACA0E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

enum {
	dmHdrAttrResDB = 0x0001, 
	dmHdrAttrReadOnly = 0x0002, 
	dmHdrAttrAppInfoDirty = 0x0004,
	dmHdrAttrBackup = 0x0008,
	dmHdrAttrOKToInstallNewer = 0x0010,
	dmHdrAttrResetAfterInstall = 0x0020,
	dmHdrAttrOpen = 0x8000,

	dmRecAttrDelete = 0x0080,
	dmRecAttrDirty = 0x0040,
	dmRecAttrBusy = 0x0020,
	dmRecAttrSecret = 0x0010,
	dmRecAttrCategoryMask = 0x000F
};


typedef struct pdbHeaderTag { 
    CString	strName;
    int		intAttr;
    int		intVers;
    long	lngCreate;
    long	lngMod;
    long	lngBackUp;
    long	lngModNum;
    long	lngAppInfoArea;
    long	lngSortArea;
    CString	strType;
    CString	strCreator;
    long	lngSeed;
    long	lngNextRec;
    int		intNumRecs;
} pdbHeader, *lppdbHeader;


typedef struct pdbRecInfoTag {
    long			lngOffset;
    BYTE			bytAttr;
    unsigned long	lngUniqueID;
} pdbRecInfo, *lppdbRecInfol;

long GetLong(CFile& filInput);
unsigned long GetULong(CFile& filInput);
int GetInt(CFile& filInput);
unsigned int GetUInt(CFile& filInput);
CString GetString(CFile& filInput, long lngSize=0);

void GetHeader(CFile& filInput, pdbHeader* puctHeader);
void GetRecInfo(CFile& filInput, pdbRecInfo* puctRecInfo);

#endif // !defined(AFX_PDB_H__13A883E7_766F_11D3_B790_00508B0ACA0E__INCLUDED_)
