/*
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License. 
 * 
 * The Original Code is pilot-mailsync.
 * 
 * The Initial Developer of the Original Code is Hollis Blanchard
 * <hollis@andrew.cmu.edu>. Portions created by Hollis Blanchard are Copyright
 * (C) 2000 Hollis Blanchard. All Rights Reserved.
 * 
 * Contributor(s):
 * 
 */

#include "llist.h"
#include <stdlib.h>

void
push(listItem **list, void *data)
{
	listItem *head = (listItem *)malloc(sizeof(listItem));

	if (list)
		head->next = *list;
	else
		head->next = NULL;

	head->data = data;
	*list = head;
}

void *
pop(listItem **list)
{
	listItem *head;
	void *data;

	if (list == NULL || *list == NULL)
		return NULL;

	head = *list;
	data = head->data;
	*list = head->next;
	free(head);

	return data;
}

